! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Function of Chemical Model File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cbm5_Function.f90
! Time                 : Fri Jan 29 14:37:03 2010
! Working directory    : /gpfs/projects/bsc32/bsc32771/UMO/UMO-Chem/chemistry/KPP/kpp-2.2.1.December2006/models/CBM5
! Equation file        : cbm5.kpp
! Output root filename : cbm5
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE cbm5_Function

  USE cbm5_Parameters
  IMPLICIT NONE

! A - Rate for each equation
  REAL(kind=dp) :: A(NREACT)

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Fun - time derivatives of variables - Agregate form
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      Vdot      - Time derivative of variable species concentrations
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Fun ( V, F, RCT, Vdot )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! Vdot - Time derivative of variable species concentrations
  REAL(kind=dp) :: Vdot(NVAR)


! Computation of equation rates
  A(1) = RCT(1)*V(51)
  A(2) = RCT(2)*V(45)*F(3)*F(5)
  A(3) = RCT(3)*V(41)*V(50)
  A(4) = RCT(4)*V(45)*V(51)
  A(5) = RCT(5)*V(45)*V(51)
  A(6) = RCT(6)*V(45)*V(50)
  A(7) = RCT(7)*V(41)*V(51)
  A(8) = RCT(8)*V(41)
  A(9) = RCT(9)*V(41)
  A(10) = RCT(10)*V(3)*F(5)
  A(11) = 2.2e-10*V(3)*F(1)
  A(12) = RCT(12)*V(41)*V(48)
  A(13) = RCT(13)*V(41)*V(43)
  A(14) = RCT(14)*V(49)
  A(15) = RCT(15)*V(49)
  A(16) = RCT(16)*V(49)*V(50)
  A(17) = RCT(17)*V(49)*V(51)
  A(18) = RCT(18)*V(49)*V(51)
  A(19) = 2.5e-22*V(8)*F(1)
  A(20) = 1.8e-39*V(8)*F(1)*F(1)
  A(21) = RCT(21)*V(8)
  A(22) = RCT(22)*V(50)*V(50)*F(3)
  A(23) = 5e-40*V(50)*V(51)*F(1)
  A(24) = RCT(24)*V(48)*V(50)
  A(25) = RCT(25)*V(11)
  A(26) = RCT(26)*V(11)*V(48)
  A(27) = 1e-20*V(11)*V(11)
  A(28) = RCT(28)*V(48)*V(51)
  A(29) = RCT(29)*V(27)*V(48)
  A(30) = RCT(30)*V(43)*V(50)
  A(31) = RCT(31)*V(43)*V(51)
  A(32) = RCT(32)*V(17)
  A(33) = RCT(33)*V(17)*V(48)
  A(34) = RCT(34)*V(43)*V(43)
  A(35) = RCT(35)*V(43)*V(43)*F(1)
  A(36) = RCT(36)*V(12)
  A(37) = RCT(37)*V(12)*V(48)
  A(38) = 1.1e-10*V(3)*F(2)
  A(39) = RCT(39)*V(48)*F(2)
  A(40) = RCT(40)*V(45)*V(48)
  A(41) = RCT(41)*V(48)*V(48)
  A(42) = RCT(42)*V(48)*V(48)
  A(43) = RCT(43)*V(43)*V(48)
  A(44) = RCT(44)*V(43)*V(45)
  A(45) = RCT(45)*V(12)*V(45)
  A(46) = 1e-11*V(45)*V(49)
  A(47) = 2.2e-11*V(48)*V(49)
  A(48) = 3.5e-12*V(43)*V(49)
  A(49) = 1e-17*V(41)*V(49)
  A(50) = RCT(50)*V(49)*V(49)
  A(51) = RCT(51)*V(17)
  A(52) = RCT(52)*V(27)
  A(53) = RCT(53)*V(8)
  A(54) = RCT(54)*V(42)*V(50)
  A(55) = RCT(55)*V(36)*V(50)
  A(56) = RCT(56)*V(42)*V(43)
  A(57) = RCT(57)*V(36)*V(43)
  A(58) = 6.8e-14*V(42)*V(42)
  A(59) = 6.8e-14*V(36)*V(36)
  A(60) = 6.8e-14*V(36)*V(42)
  A(61) = RCT(61)*V(40)*V(48)
  A(62) = RCT(62)*V(40)
  A(63) = RCT(63)*V(21)*V(48)
  A(64) = RCT(64)*V(21)
  A(65) = RCT(65)*V(25)*V(48)
  A(66) = RCT(66)*V(48)*F(4)
  A(67) = RCT(67)*V(44)*V(50)
  A(68) = RCT(68)*V(43)*V(44)
  A(69) = RCT(69)*V(44)*V(44)
  A(70) = RCT(70)*V(24)*V(48)
  A(71) = RCT(71)*V(24)
  A(72) = RCT(72)*V(7)*V(48)
  A(73) = 9e-12*V(39)*V(48)
  A(74) = RCT(74)*V(39)
  A(75) = RCT(75)*V(39)
  A(76) = RCT(76)*V(39)*V(45)
  A(77) = 5.8e-16*V(39)*V(49)
  A(78) = RCT(78)*V(39)*V(43)
  A(79) = RCT(79)*V(19)
  A(80) = 5.6e-12*V(19)*V(50)
  A(81) = RCT(81)*V(19)*V(43)
  A(82) = 4e-13*V(13)*V(48)
  A(83) = RCT(83)*V(38)*V(45)
  A(84) = RCT(84)*V(38)*V(48)
  A(85) = RCT(85)*V(38)*V(49)
  A(86) = RCT(86)*V(38)
  A(87) = RCT(87)*V(46)*V(50)
  A(88) = RCT(88)*V(46)*V(51)
  A(89) = RCT(89)*V(4)
  A(90) = RCT(90)*V(4)
  A(91) = RCT(91)*V(43)*V(46)
  A(92) = RCT(92)*V(44)*V(46)
  A(93) = RCT(93)*V(42)*V(46)
  A(94) = RCT(94)*V(46)*V(46)
  A(95) = RCT(95)*V(14)*V(48)
  A(96) = RCT(96)*V(14)
  A(97) = RCT(97)*V(15)*V(48)
  A(98) = RCT(98)*V(37)*V(45)
  A(99) = RCT(99)*V(37)*V(48)
  A(100) = 6.5e-15*V(37)*V(49)
  A(101) = RCT(101)*V(37)
  A(102) = RCT(102)*V(47)*V(50)
  A(103) = RCT(103)*V(47)*V(51)
  A(104) = RCT(104)*V(16)
  A(105) = RCT(105)*V(16)
  A(106) = 3e-13*V(16)*V(48)
  A(107) = RCT(107)*V(43)*V(47)
  A(108) = RCT(108)*V(44)*V(47)
  A(109) = RCT(109)*V(42)*V(47)
  A(110) = RCT(110)*V(47)*V(47)
  A(111) = RCT(111)*V(46)*V(47)
  A(112) = 8.1e-13*V(33)*V(48)
  A(113) = RCT(113)*V(23)
  A(114) = 1600*V(23)
  A(115) = 1.5e-11*V(23)*V(51)
  A(116) = RCT(116)*V(30)*V(45)
  A(117) = 3.2e-11*V(30)*V(48)
  A(118) = RCT(118)*V(30)*V(41)
  A(119) = RCT(119)*V(30)*V(49)
  A(120) = RCT(120)*V(28)*V(45)
  A(121) = RCT(121)*V(28)*V(48)
  A(122) = RCT(122)*V(28)*V(41)
  A(123) = RCT(123)*V(28)*V(49)
  A(124) = 2.3e-11*V(29)*V(45)
  A(125) = RCT(125)*V(29)*V(48)
  A(126) = RCT(126)*V(29)*V(41)
  A(127) = RCT(127)*V(29)*V(49)
  A(128) = RCT(128)*V(5)*V(48)
  A(129) = 8.1e-12*V(18)*V(50)
  A(130) = 4.2*V(18)
  A(131) = 4.1e-11*V(31)*V(48)
  A(132) = 2.2e-11*V(31)*V(49)
  A(133) = 1.4e-11*V(22)*V(51)
  A(134) = 5.5e-12*V(22)*V(43)
  A(135) = RCT(135)*V(26)
  A(136) = 3e-11*V(26)*V(48)
  A(137) = RCT(137)*V(26)*V(41)
  A(138) = RCT(138)*V(10)*V(48)
  A(139) = 1.7e-11*V(20)*V(48)
  A(140) = RCT(140)*V(20)
  A(141) = 3.6e-11*V(34)*V(45)
  A(142) = RCT(142)*V(34)*V(48)
  A(143) = RCT(143)*V(34)*V(41)
  A(144) = RCT(144)*V(34)*V(49)
  A(145) = 3.36e-11*V(35)*V(48)
  A(146) = 7.1e-18*V(35)*V(41)
  A(147) = 1e-15*V(35)*V(49)
  A(148) = RCT(148)*V(35)
  A(149) = 3.6e-11*V(32)*V(45)
  A(150) = RCT(150)*V(32)*V(48)
  A(151) = RCT(151)*V(32)*V(41)
  A(152) = RCT(152)*V(32)*V(49)
  A(153) = RCT(153)*V(2)*V(48)
  A(154) = RCT(154)*V(9)*V(48)
  A(155) = RCT(155)*V(6)*V(48)
  A(156) = 1.5e-19*V(34)*V(51)

! Aggregate function
  Vdot(1) = A(153)
  Vdot(2) = -A(153)
  Vdot(3) = A(9)-A(10)-A(11)-A(38)
  Vdot(4) = A(88)-A(89)-A(90)
  Vdot(5) = -A(128)
  Vdot(6) = -A(155)
  Vdot(7) = 0.63*A(69)-A(72)
  Vdot(8) = A(18)-A(19)-A(20)-A(21)-A(53)
  Vdot(9) = -A(154)
  Vdot(10) = -A(138)
  Vdot(11) = 2*A(23)+A(24)-A(25)-A(26)-2*A(27)
  Vdot(12) = A(34)+A(35)-A(36)-A(37)+A(42)-A(45)
  Vdot(13) = A(80)-A(82)+0.37*A(122)
  Vdot(14) = 0.8*A(91)-A(95)-A(96)+0.8*A(107)
  Vdot(15) = 0.2*A(91)+0.1*A(92)+0.1*A(93)-A(97)+0.2*A(107)+0.1*A(108)+0.1*A(109)
  Vdot(16) = A(103)-A(104)-A(105)-A(106)
  Vdot(17) = A(31)-A(32)-A(33)-A(51)
  Vdot(18) = 0.56*A(128)-A(129)-A(130)+0.3*A(138)
  Vdot(19) = A(78)-A(79)-A(80)-A(81)
  Vdot(20) = 0.2*A(137)+0.8*A(138)-A(139)-A(140)+0.168*A(145)+0.85*A(146)
  Vdot(21) = A(56)+A(57)-A(63)-A(64)
  Vdot(22) = 0.4*A(131)+A(132)-A(133)-A(134)
  Vdot(23) = 0.76*A(112)-0.98*A(113)-A(114)-A(115)
  Vdot(24) = A(68)-A(70)-A(71)+A(81)
  Vdot(25) = -A(65)+A(73)+A(74)+A(75)+A(76)+A(77)+A(86)+A(101)+0.2*A(116)+0.33*A(118)+A(120)+0.63*A(122)+0.1*A(124)+0.25&
               &*A(126)+A(135)+2*A(136)+0.69*A(137)+A(140)+0.066*A(143)+0.334*A(145)+0.225*A(146)+0.643*A(147)+0.333*A(148)&
               &+0.001*A(151)
  Vdot(26) = 0.9*A(129)+0.3*A(131)-A(135)-A(136)-A(137)
  Vdot(27) = 2*A(19)+2*A(20)+A(28)-A(29)+A(48)-A(52)+A(61)+A(77)+A(85)+A(100)+A(132)+0.15*A(147)
  Vdot(28) = -A(120)-A(121)-A(122)-A(123)
  Vdot(29) = -A(124)-A(125)-A(126)-A(127)
  Vdot(30) = -A(116)-A(117)-A(118)-A(119)
  Vdot(31) = 0.36*A(128)+A(130)-A(131)-A(132)+A(134)+0.2*A(138)
  Vdot(32) = -A(149)-A(150)-A(151)-A(152)
  Vdot(33) = -0.66*A(61)-0.66*A(62)-1.11*A(112)-2.1*A(113)+0.2*A(116)-0.7*A(117)-A(118)-A(119)+0.1*A(124)+1.1*A(138)&
               &+0.25*A(141)+0.35*A(143)+2.4*A(144)+1.565*A(145)+0.36*A(146)+1.282*A(147)+0.832*A(148)+5.12*A(149)+1.66&
               &*A(150)+7*A(151)+2.4*A(156)
  Vdot(34) = -A(141)-A(142)-A(143)-A(144)-A(156)
  Vdot(35) = 0.75*A(141)+0.912*A(142)+0.65*A(143)+0.2*A(144)-A(145)-A(146)-A(147)-A(148)+0.2*A(156)
  Vdot(36) = -A(55)-A(57)-2*A(59)-A(60)+0.13*A(112)+0.04*A(113)+0.01*A(116)+0.09*A(119)+0.088*A(142)+0.25*A(150)+0.18&
               &*A(151)+0.25*A(152)+0.009*A(155)
  Vdot(37) = 0.33*A(61)+0.33*A(62)+0.5*A(63)+0.5*A(64)-A(98)-A(99)-A(100)-A(101)+0.05*A(112)+0.5*A(113)+0.3*A(116)+0.62&
               &*A(117)+0.32*A(118)+0.56*A(119)+0.22*A(121)+0.66*A(124)+0.7*A(125)+0.35*A(126)+0.64*A(127)+0.03*A(137)+0.15&
               &*A(143)+0.8*A(144)+0.12*A(145)+0.375*A(147)+0.15*A(149)+0.47*A(150)+0.21*A(151)+0.47*A(152)+0.05*A(154)+0.8&
               &*A(156)
  Vdot(38) = 0.33*A(61)+0.33*A(62)+0.5*A(63)+0.5*A(64)-A(83)-A(84)-A(85)-A(86)+A(102)+A(106)+0.9*A(108)+0.9*A(109)+2&
               &*A(110)+A(111)+0.06*A(112)+0.6*A(113)+0.2*A(116)+0.33*A(117)+0.18*A(118)+0.35*A(119)+1.24*A(124)+1.3*A(125)&
               &+0.65*A(126)+1.18*A(127)+0.252*A(145)+0.02*A(146)+0.067*A(148)+0.9*A(154)+0.991*A(155)
  Vdot(39) = 0.33*A(61)+0.33*A(62)+A(67)+1.37*A(69)+A(71)+A(72)-A(73)-A(74)-A(75)-A(76)-A(77)-A(78)+A(79)+A(92)+0.1&
               &*A(108)+0.2*A(116)+0.8*A(117)+0.74*A(118)+A(119)+A(120)+1.56*A(121)+A(122)+2*A(123)+0.25*A(126)+A(136)+0.7&
               &*A(137)+0.5*A(141)+0.629*A(142)+0.6*A(143)+0.167*A(145)+0.15*A(146)+0.282*A(147)+0.9*A(148)+0.28*A(150)+0.24&
               &*A(151)+0.1*A(154)
  Vdot(40) = A(55)-A(61)-A(62)+A(115)+0.1*A(129)+A(133)+0.8*A(144)+0.85*A(147)+0.53*A(152)+0.8*A(156)
  Vdot(41) = A(2)-A(3)-A(7)-A(8)-A(9)-A(12)-A(13)-A(49)+0.2*A(91)+0.2*A(107)-A(118)-A(122)-A(126)-A(137)-A(143)-A(146)&
               &-A(151)
  Vdot(42) = -A(54)-A(56)-2*A(58)-A(60)+A(63)+0.3*A(70)-A(93)+A(102)+0.9*A(108)-A(109)+2*A(110)+A(111)+0.87*A(112)+0.96&
               &*A(113)+0.2*A(116)+0.8*A(117)+0.22*A(118)+0.91*A(119)+0.7*A(120)+A(121)+A(123)+0.1*A(124)+A(125)+0.08*A(128)&
               &+0.6*A(131)+A(136)+0.03*A(137)+0.5*A(138)+A(139)+0.25*A(141)+0.991*A(142)+0.2*A(143)+A(144)+0.713*A(145)&
               &+0.064*A(146)+0.075*A(147)+0.7*A(148)+1.25*A(150)+0.76*A(151)+1.03*A(152)+0.1*A(154)+0.991*A(155)+A(156)
  Vdot(43) = A(12)-A(13)-A(30)-A(31)+A(32)-2*A(34)-2*A(35)+A(37)+A(38)+A(39)+A(40)-A(43)-A(44)+A(45)+A(47)-A(48)+0.61&
               &*A(51)-A(56)-A(57)+A(61)+A(62)+A(64)+A(65)+A(67)-A(68)+0.74*A(69)+0.3*A(70)+A(71)+A(72)+A(73)+2*A(74)+A(76)&
               &+A(77)-A(78)+A(79)+A(80)-A(81)+A(82)+A(86)-A(91)+0.9*A(92)+A(101)+A(102)-A(107)+A(108)+2*A(110)+A(111)+0.11&
               &*A(112)+0.94*A(113)+A(114)+0.3*A(116)+0.95*A(117)+0.44*A(118)+1.7*A(120)+A(121)+0.13*A(122)+0.1*A(124)&
               &+A(125)+0.5*A(126)+A(127)+0.44*A(128)+0.9*A(129)+A(130)+0.6*A(131)-A(134)+A(135)+2*A(136)+0.76*A(137)+0.7&
               &*A(138)+A(140)+0.25*A(141)+0.912*A(142)+0.066*A(143)+0.8*A(144)+0.503*A(145)+0.154*A(146)+0.925*A(147)+1.033&
               &*A(148)+0.75*A(150)+0.07*A(151)+0.28*A(152)+A(153)+A(154)+A(155)+0.8*A(156)
  Vdot(44) = A(66)-A(67)-A(68)-2*A(69)+0.7*A(70)+A(86)+A(87)-0.1*A(92)+0.9*A(93)+2*A(94)+A(96)+A(97)+A(101)-A(108)&
               &+A(111)
  Vdot(45) = A(1)-A(2)-A(4)-A(5)-A(6)+A(8)+A(10)+A(14)-A(40)+A(41)-A(44)-A(45)-A(46)-A(76)-A(83)-A(98)-A(116)-A(120)&
               &-A(124)+0.5*A(126)-A(141)-A(149)
  Vdot(46) = A(83)+A(84)+A(85)-A(87)-A(88)+A(89)+A(90)-A(91)-A(92)-A(93)-2*A(94)+A(95)-A(111)+A(135)+A(136)+0.62*A(137)&
               &+A(139)+A(140)+0.21*A(145)+0.114*A(146)+0.967*A(148)
  Vdot(47) = A(98)+A(99)+A(100)-A(102)-A(103)+A(104)+A(105)-A(107)-A(108)-A(109)-2*A(110)-A(111)+0.25*A(141)+0.2*A(143)&
               &+0.25*A(145)+0.075*A(147)+0.39*A(151)
  Vdot(48) = 2*A(11)-A(12)+A(13)-A(24)+A(25)-A(26)-A(28)-A(29)+A(30)-A(33)+2*A(36)-A(37)+A(38)-A(39)-A(40)-2*A(41)-2&
               &*A(42)-A(43)+A(44)+A(45)-A(47)+0.39*A(51)+A(52)-A(61)-A(63)+A(64)-A(65)-A(66)-A(70)+A(71)-A(72)-A(73)+A(76)&
               &-A(82)+A(83)-A(84)-A(95)+A(96)-A(97)+A(98)-A(99)-A(106)-A(112)+0.1*A(116)-A(117)+0.1*A(118)+0.3*A(120)&
               &-A(121)+0.13*A(122)-A(125)+0.5*A(126)-A(128)-A(131)-A(136)+0.08*A(137)-A(138)-A(139)-A(142)+0.266*A(143)&
               &-A(145)+0.268*A(146)-A(150)+0.57*A(151)-A(153)-A(154)-A(155)
  Vdot(49) = A(5)+A(7)-A(14)-A(15)-A(16)-A(17)-A(18)+A(21)+A(29)-A(46)-A(47)-A(48)-A(49)-2*A(50)+0.39*A(51)+A(53)-A(77)&
               &-A(85)-A(100)-A(119)-A(123)-A(127)-A(132)-A(144)-A(147)-A(152)
  Vdot(50) = A(1)-A(3)+A(4)-A(6)+A(15)-A(16)+A(17)-2*A(22)-A(23)-A(24)+A(25)+A(27)-A(30)-A(54)-A(55)-A(67)-A(80)-A(87)&
               &-A(102)-A(129)+0.2*A(156)
  Vdot(51) = -A(1)+A(3)-A(4)-A(5)+A(6)-A(7)+A(14)+2*A(16)-A(18)+A(21)+2*A(22)-A(23)+A(26)+A(27)-A(28)+A(30)-A(31)+A(32)&
               &+A(33)+A(46)+A(47)+A(49)+2*A(50)+0.61*A(51)+A(52)+A(53)+A(54)+A(62)+A(67)+A(80)+A(87)-A(88)+A(89)+A(90)&
               &+A(102)-A(103)+A(104)+A(105)+A(106)-A(115)+A(119)+A(123)+A(127)+0.9*A(129)-A(133)+0.2*A(144)+0.47*A(152)&
               &-A(156)
      
END SUBROUTINE Fun

! End of Fun function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE cbm5_Function

