! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Utility Data Module File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cbm5_Monitor.f90
! Time                 : Fri Jan 29 14:37:03 2010
! Working directory    : /gpfs/projects/bsc32/bsc32771/UMO/UMO-Chem/chemistry/KPP/kpp-2.2.1.December2006/models/CBM5
! Equation file        : cbm5.kpp
! Output root filename : cbm5
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE cbm5_Monitor


  CHARACTER(LEN=12), PARAMETER, DIMENSION(56) :: SPC_NAMES = (/ &
     'SULF        ','SO2         ','O1D         ', &
     'PAN         ','TOL         ','ETHA        ', &
     'MEOH        ','N2O5        ','ETOH        ', &
     'XYL         ','HONO        ','H2O2        ', &
     'FACD        ','PACD        ','AACD        ', &
     'PANX        ','PNA         ','TO2         ', &
     'HCO3        ','MGLY        ','ROOH        ', &
     'CRO         ','ROR         ','MEPX        ', &
     'CO          ','OPEN        ','HNO3        ', &
     'ETH         ','IOLE        ','OLE         ', &
     'CRES        ','TERP        ','PAR         ', &
     'ISOP        ','ISPD        ','XO2N        ', &
     'ALDX        ','ALD2        ','FORM        ', &
     'NTR         ','O3          ','XO2         ', &
     'HO2         ','MEO2        ','O           ', &
     'C2O3        ','CXO3        ','OH          ', &
     'NO3         ','NO          ','NO2         ', &
     'H2O         ','H2          ','O2          ', &
     'CH4         ','M           ' /)

  INTEGER, PARAMETER, DIMENSION(56) :: LOOKAT = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, &
      13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, &
      25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, &
      37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, &
      49, 50, 51, 52, 53, 54, 55, 56 /)

  INTEGER, PARAMETER, DIMENSION(1) :: MONITOR = (/ &
      41 /)

  CHARACTER(LEN=12), DIMENSION(1) :: SMASS
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_0 = (/ &
     '           NO2 --> O + NO                                                                           ', &
     '    O + O2 + M --> O3 + M                                                                           ', &
     '       O3 + NO --> NO2                                                                              ', &
     '       O + NO2 --> NO                                                                               ', &
     '       O + NO2 --> NO3                                                                              ', &
     '        O + NO --> NO2                                                                              ', &
     '      O3 + NO2 --> NO3                                                                              ', &
     '            O3 --> O                                                                                ', &
     '            O3 --> O1D                                                                              ', &
     '       O1D + M --> O + M                                                                            ', &
     '     O1D + H2O --> 2 OH                                                                             ', &
     '       O3 + OH --> HO2                                                                              ', &
     '      O3 + HO2 --> OH                                                                               ', &
     '           NO3 --> O + NO2                                                                          ', &
     '           NO3 --> NO                                                                               ', &
     '      NO3 + NO --> 2 NO2                                                                            ', &
     '     NO3 + NO2 --> NO + NO2                                                                         ', &
     '     NO3 + NO2 --> N2O5                                                                             ', &
     '    N2O5 + H2O --> 2 HNO3                                                                           ', &
     '  N2O5 + 2 H2O --> 2 HNO3                                                                           ', &
     '          N2O5 --> NO3 + NO2                                                                        ', &
     '     2 NO + O2 --> 2 NO2                                                                            ', &
     'NO + NO2 + H2O --> 2 HONO                                                                           ', &
     '       OH + NO --> HONO                                                                             ', &
     '          HONO --> OH + NO                                                                          ', &
     '     HONO + OH --> NO2                                                                              ', &
     '        2 HONO --> NO + NO2                                                                         ', &
     '      OH + NO2 --> HNO3                                                                             ', &
     '     HNO3 + OH --> NO3                                                                              ', &
     '      HO2 + NO --> OH + NO2                                                                         ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_1 = (/ &
     '     HO2 + NO2 --> PNA                                                                              ', &
     '           PNA --> HO2 + NO2                                                                        ', &
     '      PNA + OH --> NO2                                                                              ', &
     '         2 HO2 --> H2O2                                                                             ', &
     '   2 HO2 + H2O --> H2O2                                                                             ', &
     '          H2O2 --> 2 OH                                                                             ', &
     '     H2O2 + OH --> HO2                                                                              ', &
     '      O1D + H2 --> HO2 + OH                                                                         ', &
     '       OH + H2 --> HO2                                                                              ', &
     '        O + OH --> HO2                                                                              ', &
     '          2 OH --> O                                                                                ', &
     '          2 OH --> H2O2                                                                             ', &
     '      HO2 + OH --> H2O + O2                                                                         ', &
     '       HO2 + O --> OH                                                                               ', &
     '      H2O2 + O --> HO2 + OH                                                                         ', &
     '       O + NO3 --> NO2                                                                              ', &
     '      OH + NO3 --> HO2 + NO2                                                                        ', &
     '     HO2 + NO3 --> HNO3                                                                             ', &
     '      O3 + NO3 --> NO2                                                                              ', &
     '         2 NO3 --> 2 NO2                                                                            ', &
     '           PNA --> 0.61 HO2 + 0.39 OH + 0.39 NO3 + 0.61 NO2                                         ', &
     '          HNO3 --> OH + NO2                                                                         ', &
     '          N2O5 --> NO3 + NO2                                                                        ', &
     '      XO2 + NO --> NO2                                                                              ', &
     '     XO2N + NO --> NTR                                                                              ', &
     '     XO2 + HO2 --> ROOH                                                                             ', &
     '    XO2N + HO2 --> ROOH                                                                             ', &
     '         2 XO2 --> 2 O2                                                                             ', &
     '        2 XO2N --> 2 O2                                                                             ', &
     '    XO2N + XO2 --> 2 O2                                                                             ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_2 = (/ &
     '      NTR + OH --> HNO3 - 0.66 PAR + 0.33 ALDX + 0.33 ALD2 + 0.33 FORM ... etc.                     ', &
     '           NTR --> - 0.66 PAR + 0.33 ALDX + 0.33 ALD2 + 0.33 FORM + HO2 ... etc.                    ', &
     '     ROOH + OH --> 0.5 ALDX + 0.5 ALD2 + XO2                                                        ', &
     '          ROOH --> 0.5 ALDX + 0.5 ALD2 + HO2 + OH                                                   ', &
     '       CO + OH --> HO2                                                                              ', &
     '      OH + CH4 --> MEO2                                                                             ', &
     '     MEO2 + NO --> FORM + HO2 + NO2                                                                 ', &
     '    HO2 + MEO2 --> MEPX                                                                             ', &
     '        2 MEO2 --> 0.63 MEOH + 1.37 FORM + 0.74 HO2                                                 ', &
     '     MEPX + OH --> 0.3 XO2 + 0.3 HO2 + 0.7 MEO2                                                     ', &
     '          MEPX --> FORM + HO2 + OH                                                                  ', &
     '     MEOH + OH --> FORM + HO2                                                                       ', &
     '     FORM + OH --> CO + HO2                                                                         ', &
     '          FORM --> CO + 2 HO2                                                                       ', &
     '          FORM --> CO                                                                               ', &
     '      FORM + O --> CO + HO2 + OH                                                                    ', &
     '    FORM + NO3 --> CO + HNO3 + HO2                                                                  ', &
     '    FORM + HO2 --> HCO3                                                                             ', &
     '          HCO3 --> FORM + HO2                                                                       ', &
     '     HCO3 + NO --> FACD + HO2 + NO2                                                                 ', &
     '    HCO3 + HO2 --> MEPX                                                                             ', &
     '     FACD + OH --> HO2                                                                              ', &
     '      ALD2 + O --> C2O3 + OH                                                                        ', &
     '     ALD2 + OH --> C2O3                                                                             ', &
     '    ALD2 + NO3 --> HNO3 + C2O3                                                                      ', &
     '          ALD2 --> CO + HO2 + MEO2                                                                  ', &
     '     C2O3 + NO --> MEO2 + NO2                                                                       ', &
     '    C2O3 + NO2 --> PAN                                                                              ', &
     '           PAN --> C2O3 + NO2                                                                       ', &
     '           PAN --> C2O3 + NO2                                                                       ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_3 = (/ &
     '    HO2 + C2O3 --> 0.8 PACD + 0.2 AACD + 0.2 O3                                                     ', &
     '   MEO2 + C2O3 --> 0.1 AACD + FORM + 0.9 HO2 + 0.9 MEO2                                             ', &
     '    XO2 + C2O3 --> 0.1 AACD + 0.9 MEO2                                                              ', &
     '        2 C2O3 --> 2 MEO2                                                                           ', &
     '     PACD + OH --> C2O3                                                                             ', &
     '          PACD --> MEO2 + OH                                                                        ', &
     '     AACD + OH --> MEO2                                                                             ', &
     '      ALDX + O --> CXO3 + OH                                                                        ', &
     '     ALDX + OH --> CXO3                                                                             ', &
     '    ALDX + NO3 --> HNO3 + CXO3                                                                      ', &
     '          ALDX --> CO + HO2 + MEO2                                                                  ', &
     '     CXO3 + NO --> ALD2 + XO2 + HO2 + NO2                                                           ', &
     '    CXO3 + NO2 --> PANX                                                                             ', &
     '          PANX --> CXO3 + NO2                                                                       ', &
     '          PANX --> CXO3 + NO2                                                                       ', &
     '     PANX + OH --> ALD2 + NO2                                                                       ', &
     '    HO2 + CXO3 --> 0.8 PACD + 0.2 AACD + 0.2 O3                                                     ', &
     '   MEO2 + CXO3 --> 0.1 AACD + 0.9 ALD2 + 0.1 FORM + 0.9 XO2 + HO2                                   ', &
     '    XO2 + CXO3 --> 0.1 AACD + 0.9 ALD2                                                              ', &
     '        2 CXO3 --> 2 ALD2 + 2 XO2 + 2 HO2                                                           ', &
     '   C2O3 + CXO3 --> ALD2 + XO2 + HO2 + MEO2                                                          ', &
     '      PAR + OH --> 0.76 ROR - 0.11 PAR + 0.13 XO2N + 0.05 ALDX + 0.06 ALD2 ... etc.                 ', &
     '           ROR --> 0.02 ROR - 2.1 PAR + 0.04 XO2N + 0.5 ALDX + 0.6 ALD2 ... etc.                    ', &
     '           ROR --> HO2                                                                              ', &
     '     ROR + NO2 --> NTR                                                                              ', &
     '       OLE + O --> 0.2 CO + 0.2 PAR + 0.01 XO2N + 0.3 ALDX + 0.2 ALD2 + 0.2 FORM ... etc.           ', &
     '      OLE + OH --> - 0.7 PAR + 0.62 ALDX + 0.33 ALD2 + 0.8 FORM + 0.8 XO2 ... etc.                  ', &
     '      OLE + O3 --> 0.33 CO - PAR + 0.32 ALDX + 0.18 ALD2 + 0.74 FORM + 0.22 XO2 ... etc.            ', &
     '     OLE + NO3 --> - PAR + 0.09 XO2N + 0.56 ALDX + 0.35 ALD2 + FORM + 0.91 XO2 ... etc.             ', &
     '       ETH + O --> CO + FORM + 0.7 XO2 + 1.7 HO2 + 0.3 OH                                           ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_4 = (/ &
     '      ETH + OH --> 0.22 ALDX + 1.56 FORM + XO2 + HO2                                                ', &
     '      ETH + O3 --> 0.37 FACD + 0.63 CO + FORM + 0.13 HO2 + 0.13 OH                                  ', &
     '     ETH + NO3 --> 2 FORM + XO2 + NO2                                                               ', &
     '      IOLE + O --> 0.1 CO + 0.1 PAR + 0.66 ALDX + 1.24 ALD2 + 0.1 XO2 + 0.1 HO2 ... etc.            ', &
     '     IOLE + OH --> 0.7 ALDX + 1.3 ALD2 + XO2 + HO2                                                  ', &
     '     IOLE + O3 --> 0.25 CO + 0.35 ALDX + 0.65 ALD2 + 0.25 FORM + 0.5 HO2 ... etc.                   ', &
     '    IOLE + NO3 --> 0.64 ALDX + 1.18 ALD2 + HO2 + NO2                                                ', &
     '      TOL + OH --> 0.56 TO2 + 0.36 CRES + 0.08 XO2 + 0.44 HO2                                       ', &
     '      TO2 + NO --> 0.9 OPEN + 0.1 NTR + 0.9 HO2 + 0.9 NO2                                           ', &
     '           TO2 --> CRES + HO2                                                                       ', &
     '     CRES + OH --> 0.4 CRO + 0.3 OPEN + 0.6 XO2 + 0.6 HO2                                           ', &
     '    CRES + NO3 --> CRO + HNO3                                                                       ', &
     '     CRO + NO2 --> NTR                                                                              ', &
     '     CRO + HO2 --> CRES                                                                             ', &
     '          OPEN --> CO + HO2 + C2O3                                                                  ', &
     '     OPEN + OH --> 2 CO + FORM + XO2 + 2 HO2 + C2O3                                                 ', &
     '     OPEN + O3 --> 0.2 MGLY + 0.69 CO + 0.03 ALDX + 0.7 FORM + 0.03 XO2 ... etc.                    ', &
     '      XYL + OH --> 0.3 TO2 + 0.8 MGLY + 0.2 CRES + 1.1 PAR + 0.5 XO2 + 0.7 HO2 ... etc.             ', &
     '     MGLY + OH --> XO2 + C2O3                                                                       ', &
     '          MGLY --> CO + HO2 + C2O3                                                                  ', &
     '      ISOP + O --> 0.25 PAR + 0.75 ISPD + 0.5 FORM + 0.25 XO2 + 0.25 HO2 ... etc.                   ', &
     '     ISOP + OH --> 0.912 ISPD + 0.088 XO2N + 0.629 FORM + 0.991 XO2 + 0.912 HO2 ... etc.            ', &
     '     ISOP + O3 --> 0.066 CO + 0.35 PAR + 0.65 ISPD + 0.15 ALDX + 0.6 FORM ... etc.                  ', &
     '    ISOP + NO3 --> 2.4 PAR + 0.2 ISPD + 0.8 ALDX + 0.8 NTR + XO2 + 0.8 HO2 ... etc.                 ', &
     '     ISPD + OH --> 0.168 MGLY + 0.334 CO + 1.565 PAR + 0.12 ALDX + 0.252 ALD2 ... etc.              ', &
     '     ISPD + O3 --> 0.85 MGLY + 0.225 CO + 0.36 PAR + 0.02 ALD2 + 0.15 FORM ... etc.                 ', &
     '    ISPD + NO3 --> 0.643 CO + 0.15 HNO3 + 1.282 PAR + 0.375 ALDX + 0.282 FORM ... etc.              ', &
     '          ISPD --> 0.333 CO + 0.832 PAR + 0.067 ALD2 + 0.9 FORM + 0.7 XO2 ... etc.                  ', &
     '      TERP + O --> 5.12 PAR + 0.15 ALDX                                                             ', &
     '     TERP + OH --> 1.66 PAR + 0.25 XO2N + 0.47 ALDX + 0.28 FORM + 1.25 XO2 ... etc.                 ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(6) :: EQN_NAMES_5 = (/ &
     '     TERP + O3 --> 0.001 CO + 7 PAR + 0.18 XO2N + 0.21 ALDX + 0.24 FORM ... etc.                    ', &
     '    TERP + NO3 --> 0.25 XO2N + 0.47 ALDX + 0.53 NTR + 1.03 XO2 + 0.28 HO2 ... etc.                  ', &
     '      SO2 + OH --> SULF + HO2                                                                       ', &
     '     ETOH + OH --> 0.05 ALDX + 0.9 ALD2 + 0.1 FORM + 0.1 XO2 + HO2                                  ', &
     '     ETHA + OH --> 0.009 XO2N + 0.991 ALD2 + 0.991 XO2 + HO2                                        ', &
     '    ISOP + NO2 --> 2.4 PAR + 0.2 ISPD + 0.8 ALDX + 0.8 NTR + XO2 + 0.8 HO2 ... etc.                 ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(156) :: EQN_NAMES = (/&
    EQN_NAMES_0, EQN_NAMES_1, EQN_NAMES_2, EQN_NAMES_3, EQN_NAMES_4, &
    EQN_NAMES_5 /)

! INLINED global variables

! End INLINED global variables


END MODULE cbm5_Monitor
